package pps.core.common.config;

import pps.core.common.utils.TimeSpanChecker;
import xstartup.annotation.XConfig;
import xstartup.base.XContext;
import xstartup.config.XBooleanConfigItem;
import xstartup.config.XConfigMetadata;

@XConfig
public class ExceptionDebugConfig {

    public static final XBooleanConfigItem dontShowExceptionDebugConfig = XConfigMetadata.register(TraceLogConfig.class,
            "dontShowExceptionDebug",
            XBooleanConfigItem.class);
    /**
     * 不显示诊断信息
     */
    private static boolean dontShowExceptionDebug = false;
    private static TimeSpanChecker checker = new TimeSpanChecker(60, false);

    public static boolean checkDontShowExceptionDebug(XContext context) {
        if (checker.checkNow()) {
            dontShowExceptionDebug = dontShowExceptionDebugConfig.getValueNotNull(context);
        }
        return dontShowExceptionDebug;
    }
}
