package pps.core.common.mq;

import pps.core.common.data.FormBizDataRecord;
import xstartup.base.mq.XMqMessage;

import java.util.Arrays;
import java.util.List;
import java.util.UUID;

/**
 * @author xcd
 * @version V1.0
 * @Description: 发送给 分析库 的 数据记录
 * @date 2022/10/13
 */
public class FormBizDataRecordMessage extends XMqMessage {

    // 表名
    private String tableName;
    // 表单标签
    private String formTag;
    private String formInputRecordId;
    private String dataDate;
    private String originalMessageId;
    private List<FormBizDataRecord> records;

    public FormBizDataRecordMessage() {
        setMessageTag(UUID.randomUUID().toString().replace("-", ""));
        setMessageId(UUID.randomUUID().toString().replace("-", ""));
        setMessageKey(UUID.randomUUID().toString().replace("-", ""));
    }

    public FormBizDataRecordMessage(FormBizDataRecord[] records) {
        this.records = Arrays.asList(records);
        setMessageTag(UUID.randomUUID().toString().replace("-", ""));
        setMessageId(UUID.randomUUID().toString().replace("-", ""));
        setMessageKey(UUID.randomUUID().toString().replace("-", ""));
    }

    public FormBizDataRecordMessage(List<FormBizDataRecord> records) {
        this.records = records;
    }

    public List<FormBizDataRecord> getRecords() {
        return records;
    }

    public void setRecords(List<FormBizDataRecord> records) {
        this.records = records;
    }

    public String getTableName() {
        return tableName;
    }

    public void setTableName(String tableName) {
        this.tableName = tableName;
    }

    public String getFormTag() {
        return formTag;
    }

    public void setFormTag(String formTag) {
        this.formTag = formTag;
    }

    public String getDataDate() {
        return dataDate;
    }

    public void setDataDate(String dataDate) {
        this.dataDate = dataDate;
    }

//    @Override
//    public String getMessageTag() {
//        return UUIDHelper.newUUID();
//    }
//
//    @Override
//    public String getMessageId() {
//        return UUIDHelper.newUUID();
//    }
//
//    @Override
//    public String getMessageKey() {
//        return UUIDHelper.newUUID();
//    }

    public String getFormInputRecordId() {
        return formInputRecordId;
    }

    public void setFormInputRecordId(String formInputRecordId) {
        this.formInputRecordId = formInputRecordId;
    }

    public String getOriginalMessageId() {
        return originalMessageId;
    }

    public void setOriginalMessageId(String originalMessageId) {
        this.originalMessageId = originalMessageId;
    }
}
