package pps.core.common.mq;

import pps.core.common.data.FormBizDataRemovedRecordId;
import xstartup.base.mq.XMqMessage;

import java.util.List;
import java.util.UUID;

/**
 * @author xcd
 * @version V1.0
 * @Description: 发送给 分析库 的 已经删除的表单的记录id 的消息定义
 * @date 2022/10/13
 */
public class FormBizDataRemovedRecordIdMessage extends XMqMessage {
    // 表名
    private String tableName;
    //表单业务
    private String formTag;
    private String originalMessageId;
    private List<FormBizDataRemovedRecordId> removedRecordIds;

    public FormBizDataRemovedRecordIdMessage() {
        setMessageTag(UUID.randomUUID().toString().replace("-", ""));
        setMessageId(UUID.randomUUID().toString().replace("-", ""));
        setMessageKey(UUID.randomUUID().toString().replace("-", ""));
    }

    public String getTableName() {
        return tableName;
    }

    public void setTableName(String tableName) {
        this.tableName = tableName;
    }

    public String getFormTag() {
        return formTag;
    }

    public void setFormTag(String formTag) {
        this.formTag = formTag;
    }

    public List<FormBizDataRemovedRecordId> getRemovedRecordIds() {
        return removedRecordIds;
    }

    public void setRemovedRecordIds(List<FormBizDataRemovedRecordId> removedRecordIds) {
        this.removedRecordIds = removedRecordIds;
    }

//    @Override
//    public String getMessageTag() {
//        return UUIDHelper.newUUID();
//    }
//
//    @Override
//    public String getMessageId() {
//        return UUIDHelper.newUUID();
//    }
//
//    @Override
//    public String getMessageKey() {
//        return UUIDHelper.newUUID();
//    }

    public String getOriginalMessageId() {
        return originalMessageId;
    }

    public void setOriginalMessageId(String originalMessageId) {
        this.originalMessageId = originalMessageId;
    }
}
