package pps.core.common.pdf;

import com.itextpdf.text.pdf.BaseFont;
import org.xhtmlrenderer.pdf.ITextFontResolver;
import org.xhtmlrenderer.pdf.ITextRenderer;

import java.io.File;
import java.io.FileOutputStream;
import java.io.OutputStream;

public class HtmlPdfUtils {
    public static void html2pdf(String htmlContent, File pdfFile) throws Exception {
        OutputStream os = new FileOutputStream(pdfFile);
        ITextRenderer renderer = new ITextRenderer();
        renderer.setDocumentFromString(htmlContent);
        // 中文
        ITextFontResolver fontResolver = renderer.getFontResolver();
        BaseFont bfChinese;
        bfChinese = BaseFont.createFont("STSong-Light", "UniGB-UCS2-H", false);
        fontResolver.addFont("D:\\pdf\\msyh.ttc", BaseFont.IDENTITY_H, BaseFont.EMBEDDED);
        renderer.layout();
        renderer.createPDF(os);
        os.close();
    }

    public static void main(String[] args) throws Exception {
        File file = new File("D:/pdf/测试.pdf"); // 创建文件对象
        try {
            html2pdf("<!DOCTYPE html>\n" +
                    "<html lang=\"en\">\n" +
                    "  <head>\n" +
                    "    <meta charset=\"utf-8\" />\n" +
                    "    <title>PPS</title>\n" +
                    "\t\t<style>\n" +
                    "\t\t\ttable{\n" +
                    "\t\t\t\twidth: 100%;\n" +
                    "\t\t\t\tborder-collapse: collapse;\n" +
                    "\t\t\t\tborder-spacing: 0;\n" +
                    "\t\t\t}\n" +
                    "\t\t\ttable, th, td{\n" +
                    "\t\t\t\tborder: 1px solid #000000;\n" +
                    "\t\t\t\ttext-align: center;\n" +
                    "\t\t\t}\n" +
                    "\t\t\tth{\n" +
                    "\t\t\t\twidth: auto;\n" +
                    "\t\t\t\tline-height: 3;\n" +
                    "\t\t\t\tfont-weight: bold;\n" +
                    "\t\t\t}\n" +
                    "\t\t\ttd{\n" +
                    "\t\t\t\twidth: auto;\n" +
                    "\t\t\t\theight: 33px;\n" +
                    "\t\t\t\tline-height: 2;\n" +
                    "\t\t\t}\n" +
                    "\t\t</style>\n" +
                    "  </head>\n" +
                    "  <body>\n" +
                    "  <div>[f_gas_voucher_detail_process@voucherDetail][f_gas_voucher_process@voucher]</div>\n" +
                    "\t<div style=\"padding: 16px;box-sizing: border-box;background-color: #ffffff\">\n" +
                    "\t\t<h1 style=\"text-align: center\">32#阀室</h1>\n" +
                    "\t\t<h1 style=\"text-align: center\">天然气计量交接凭证（B032分输阀室）</h1>\n" +
                    "\t\t<h1 style=\"border-bottom: 1px solid #999;margin: 10px 0;\"></h1>\n" +
                    "\t\t<div style=\"overflow:hidden;margin: 10px 0;\">\n" +
                    "\t\t\t<div style=\"float: left;width: 50%;\">填写日期：2022-09-22</div>\n" +
                    "\t\t\t<div style=\"float: left;width: 50%;\">凭证编号：@voucher.voucher_code0</div>\n" +
                    "\t\t</div>\n" +
                    "\t\t<table  border=\"1\">\n" +
                    "\t\t\t<tr>\n" +
                    "\t\t\t\t<td>承运单位：</td>\n" +
                    "\t\t\t\t<td colspan=\"6\">32#阀室</td>\n" +
                    "\t\t\t</tr>\n" +
                    "\t\t\t<tr>\n" +
                    "\t\t\t\t<td>接收单位：</td>\n" +
                    "\t\t\t\t<td colspan=\"6\">1</td>\n" +
                    "\t\t\t</tr>\n" +
                    "\t\t\t<tr>\n" +
                    "\t\t\t\t<td>计量时间：</td>\n" +
                    "\t\t\t\t<td colspan=\"6\">2022年09月21日 08:00 至 2022年09月22日 08:00</td>\n" +
                    "\t\t\t</tr>\n" +
                    "\t\t\t<tr>\n" +
                    "\t\t\t\t<th>计量交接地点</th>\n" +
                    "\t\t\t\t<th>流量计位号</th>\n" +
                    "\t\t\t\t<th>前日日累（体积量）Nm3</th>\n" +
                    "\t\t\t\t<th>前日日累（能量）MJ</th>\n" +
                    "\t\t\t\t<th>平均高位发热量MJ/m3</th>\n" +
                    "\t\t\t\t<th>计量气量Nm3</th>\n" +
                    "\t\t\t\t<th>计量能量MJ</th>\n" +
                    "\t\t\t</tr>\n" +
                    "\t\t\t<tr>\n" +
                    "\t\t\t\t<td>B032分输阀室</td>\n" +
                    "\t\t\t\t<td>默认流量计</td>\n" +
                    "\t\t\t\t<td>3</td>\n" +
                    "\t\t\t\t<td>3</td>\n" +
                    "\t\t\t\t<td>3</td>\n" +
                    "\t\t\t\t<td>3</td>\n" +
                    "\t\t\t\t<td>3</td>\n" +
                    "\t\t\t</tr>\n" +
                    "\t\t\t<tr>\n" +
                    "\t\t\t\t<td> </td>\n" +
                    "\t\t\t\t<td> </td>\n" +
                    "\t\t\t\t<td> </td>\n" +
                    "\t\t\t\t<td> </td>\n" +
                    "\t\t\t\t<td> </td>\n" +
                    "\t\t\t\t<td> </td>\n" +
                    "\t\t\t\t<td> </td>\n" +
                    "\t\t\t</tr>\n" +
                    "\t\t\t<tr>\n" +
                    "\t\t\t\t<td> </td>\n" +
                    "\t\t\t\t<td> </td>\n" +
                    "\t\t\t\t<td> </td>\n" +
                    "\t\t\t\t<td> </td>\n" +
                    "\t\t\t\t<td> </td>\n" +
                    "\t\t\t\t<td> </td>\n" +
                    "\t\t\t\t<td> </td>\n" +
                    "\t\t\t</tr>\n" +
                    "\t\t\t<tr>\n" +
                    "\t\t\t\t<td> </td>\n" +
                    "\t\t\t\t<td> </td>\n" +
                    "\t\t\t\t<td> </td>\n" +
                    "\t\t\t\t<td> </td>\n" +
                    "\t\t\t\t<td> </td>\n" +
                    "\t\t\t\t<td> </td>\n" +
                    "\t\t\t\t<td> </td>\n" +
                    "\t\t\t</tr>\n" +
                    "\t\t\t<tr>\n" +
                    "\t\t\t\t<td> </td>\n" +
                    "\t\t\t\t<td> </td>\n" +
                    "\t\t\t\t<td> </td>\n" +
                    "\t\t\t\t<td> </td>\n" +
                    "\t\t\t\t<td> </td>\n" +
                    "\t\t\t\t<td> </td>\n" +
                    "\t\t\t\t<td> </td>\n" +
                    "\t\t\t</tr>\n" +
                    "\t\t\t<tr>\n" +
                    "\t\t\t\t<td> </td>\n" +
                    "\t\t\t\t<td> </td>\n" +
                    "\t\t\t\t<td> </td>\n" +
                    "\t\t\t\t<td> </td>\n" +
                    "\t\t\t\t<td> </td>\n" +
                    "\t\t\t\t<td> </td>\n" +
                    "\t\t\t\t<td> </td>\n" +
                    "\t\t\t</tr>\n" +
                    "\t\t\t<tr>\n" +
                    "\t\t\t\t<td> </td>\n" +
                    "\t\t\t\t<td> </td>\n" +
                    "\t\t\t\t<td> </td>\n" +
                    "\t\t\t\t<td> </td>\n" +
                    "\t\t\t\t<td> </td>\n" +
                    "\t\t\t\t<td> </td>\n" +
                    "\t\t\t\t<td> </td>\n" +
                    "\t\t\t</tr>\n" +
                    "\t\t\t<tr>\n" +
                    "\t\t\t\t<td> </td>\n" +
                    "\t\t\t\t<td> </td>\n" +
                    "\t\t\t\t<td> </td>\n" +
                    "\t\t\t\t<td> </td>\n" +
                    "\t\t\t\t<td> </td>\n" +
                    "\t\t\t\t<td> </td>\n" +
                    "\t\t\t\t<td> </td>\n" +
                    "\t\t\t</tr>\n" +
                    "\t\t\t<tr>\n" +
                    "\t\t\t\t<td> </td>\n" +
                    "\t\t\t\t<td> </td>\n" +
                    "\t\t\t\t<td> </td>\n" +
                    "\t\t\t\t<td> </td>\n" +
                    "\t\t\t\t<td> </td>\n" +
                    "\t\t\t\t<td> </td>\n" +
                    "\t\t\t\t<td> </td>\n" +
                    "\t\t\t</tr>\n" +
                    "\t\t\t<tr>\n" +
                    "\t\t\t\t<td> </td>\n" +
                    "\t\t\t\t<td> </td>\n" +
                    "\t\t\t\t<td> </td>\n" +
                    "\t\t\t\t<td> </td>\n" +
                    "\t\t\t\t<td> </td>\n" +
                    "\t\t\t\t<td> </td>\n" +
                    "\t\t\t\t<td> </td>\n" +
                    "\t\t\t</tr>\n" +
                    "\t\t\t<tr>\n" +
                    "\t\t\t\t<td colspan=\"2\">合计交接气量（小写）Nm3</td>\n" +
                    "\t\t\t\t<td colspan=\"2\">3</td>\n" +
                    "\t\t\t\t<td>合计交接能量（小写）MJ</td>\n" +
                    "\t\t\t\t<td colspan=\"2\">3</td>\n" +
                    "\t\t\t</tr>\n" +
                    "\t\t\t<tr>\n" +
                    "\t\t\t\t<td colspan=\"2\">合计交接气量（大写）Nm3</td>\n" +
                    "\t\t\t\t<td colspan=\"2\">叁标方</td>\n" +
                    "\t\t\t\t<td>合计交接能量（大写）MJ</td>\n" +
                    "\t\t\t\t<td colspan=\"2\">叁标方</td>\n" +
                    "\t\t\t</tr>\n" +
                    "\t\t\t<tr>\n" +
                    "\t\t\t\t<td>备注：</td>\n" +
                    "\t\t\t\t<td colspan=\"6\">1</td>\n" +
                    "\t\t\t</tr>\n" +
                    "\t\t\t<tr>\n" +
                    "\t\t\t\t<td colspan=\"2\">供气单位（盖章）</td>\n" +
                    "\t\t\t\t<td colspan=\"2\" style=\"opacity: 0;\"></td>\n" +
                    "\t\t\t\t<td>接气单位(盖章)</td>\n" +
                    "\t\t\t\t<td colspan=\"2\"></td>\n" +
                    "\t\t\t</tr>\n" +
                    "\t\t\t<tr>\n" +
                    "\t\t\t\t<td colspan=\"2\">供气方计量员（签字）</td>\n" +
                    "\t\t\t\t<td colspan=\"2\"></td>\n" +
                    "\t\t\t\t<td>接气方计量员(签字)</td>\n" +
                    "\t\t\t\t<td colspan=\"2\"></td>\n" +
                    "\t\t\t</tr>\n" +
                    "\t\t\t<tr>\n" +
                    "\t\t\t\t<td>争议量（+/-）：</td>\n" +
                    "\t\t\t\t<td colspan=\"6\"></td>\n" +
                    "\t\t\t</tr>\n" +
                    "\t\t</table>\n" +
                    "\t</div>\n" +
                    "  </body>\n" +
                    "</html>\n", file); // 调用封装好的工具类
        } catch (Exception e) {
            e.printStackTrace();
        } finally {
            System.err.println("转换完成");
        }

    }
}
