package pps.core.common.pdf;

import com.itextpdf.text.BaseColor;
import com.itextpdf.text.DocumentException;
import com.itextpdf.text.Image;
import com.itextpdf.text.Rectangle;
import com.itextpdf.text.pdf.*;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.List;

public class ItextPDFRepalceUtil {
    //输入的模版路径
    public static String inputFilePath = "D:\\pdf\\合同2.pdf";
    //插入的文件路径
    public static String imgFilePath = "D:\\pdf\\签名.png";
    //输出路径
    public static String out = "D:\\pdf\\out6.pdf";
    public static String keyword = "${甲方盖章}";//测试标记

    public static String keyword2 = "${乙方盖章}";//测试标记

    public static void main(String[] args) throws IOException, DocumentException {
        //replaceImg();
        //replaceText();
        addImg("D:\\pdf\\1111.pdf", "D:\\pdf\\2222.pdf", "D:\\pdf\\4444.png");
    }

    //插入图片的例子
    public static void replaceImg() throws IOException, DocumentException {
        //查找位置
        float[] position = ItextPDFUtil.getAddImagePositionXY(inputFilePath, keyword);
        if (position.length == 0)
            return;
        //Read file using PdfReader
        PdfReader pdfReader = new PdfReader(inputFilePath);

        //Modify file using PdfReader
        PdfStamper pdfStamper = new PdfStamper(pdfReader, new FileOutputStream(out));
        Image image = Image.getInstance(imgFilePath);
        //Fixed Positioning
//        image.scaleToFit(100, 50);
        image.scaleAbsolute(100, 20);
        //Scale to new height and new width of image
        image.setAbsolutePosition(position[1] - 50, position[2] + 25);
        PdfContentByte content = pdfStamper.getUnderContent((int) position[0]);
        content.addImage(image);
        pdfStamper.close();
    }

    //修改文字的示例
    public static void replaceText() {
        //1.给定文件
        File pdfFile = new File(inputFilePath);

        //2.定义一个byte数组，长度为文件的长度
        byte[] pdfData = new byte[(int) pdfFile.length()];
        //3.IO流读取文件内容到byte数组
        FileInputStream inputStream = null;
        try {
            inputStream = new FileInputStream(pdfFile);
            inputStream.read(pdfData);
        } catch (IOException e) {
            e.printStackTrace();
        } finally {
            if (inputStream != null) {
                try {
                    inputStream.close();
                } catch (IOException e) {
                }
            }
        }

        //4.指定关键字
        String replace = " 王文博 先生";
        //5.调用方法，给定关键字和文件
        List<float[]> positions = null;
        try {
            positions = ItextPDFUtil.findKeywordPostions(pdfData, keyword2);
        } catch (IOException e) {
            e.printStackTrace();
        }

        PdfReader pdfReader = null;
        PdfStamper stamper = null;
        try {
            pdfReader = new PdfReader(pdfData);
            stamper = new PdfStamper(pdfReader, new FileOutputStream(out));

            if (positions != null) {
                for (int i = 0; i < positions.size(); i++) {
                    float[] position = positions.get(i);

                    PdfContentByte canvas = stamper.getOverContent((int) position[0]);
                    //修改背景色
                    canvas.saveState();
                    canvas.setColorFill(BaseColor.WHITE);
                    canvas.rectangle(position[1], position[2], position[3] + 10, position[4] - 1);

                    canvas.fill();
                    canvas.restoreState();
                    //替换关键字
                    canvas.beginText();

                    BaseFont bf = BaseFont.createFont("STSong-Light", "UniGB-UCS2-H", BaseFont.NOT_EMBEDDED);
                    canvas.setFontAndSize(bf, 13);
                    canvas.setTextMatrix(position[1] + 3, position[2]);/*修正背景与文本的相对位置*/
                    canvas.showText(replace);
                    canvas.endText();
                }
            }
        } catch (IOException e) {
            e.printStackTrace();
        } catch (DocumentException e) {
            e.printStackTrace();
        } finally {
            if (stamper != null)
                try {
                    stamper.close();
                } catch (DocumentException e) {
                    e.printStackTrace();
                } catch (IOException e) {
                    e.printStackTrace();
                }
            if (pdfReader != null) {
                pdfReader.close();
            }
        }
    }

    public static void addImg(String inPdfFile, String outPdfFile, String imgPath) {
        try {
            PdfReader reader = new PdfReader(inPdfFile, "PDF".getBytes());
            PdfStamper stamp = new PdfStamper(reader, new FileOutputStream(outPdfFile));
            int pages = reader.getNumberOfPages();
            // 设置透明度
            PdfGState gs = new PdfGState();
            gs.setStrokeOpacity(0.9f);
            gs.setFillOpacity(0.9f);
            for (int i = 1; i <= pages; i++) {
                Rectangle cropBox = reader.getCropBox(i);

                Image img = Image.getInstance(imgPath);// 插入业务章
                //设置缩放比例
                img.scaleAbsolute(115, 115);
                //设置业务章的位置
                img.setAbsolutePosition((float) (cropBox.getWidth() * 0.7), (float) (cropBox.getHeight() * 0.65));
                PdfContentByte over = stamp.getOverContent(i);
                over.setGState(gs);
                over.addImage(img);
            }
            stamp.close();// 关闭
            File tempfile = new File(inPdfFile);
            if (tempfile.exists()) {
                tempfile.delete();
            }
        } catch (Exception e) {
            e.printStackTrace();
        }

    }
}

