package pps.core.common.pdf;

import com.itextpdf.text.DocumentException;
import com.itextpdf.text.Element;
import com.itextpdf.text.Rectangle;
import com.itextpdf.text.pdf.BaseFont;
import com.itextpdf.text.pdf.PdfContentByte;
import com.itextpdf.text.pdf.PdfReader;
import com.itextpdf.text.pdf.PdfStamper;

import java.io.*;


public class UpdatePdfUtil {

    /**
     * @param bytes       数组
     * @param contentText 添加的文字
     * @return
     * @throws Exception
     */
    public static InputStream addText(byte[] bytes, String contentText)
            throws Exception {
        ByteArrayOutputStream byteArrayOutputStream = null;
        PdfReader pdfReader = null;
        PdfStamper stamper = null;
        try {
            byteArrayOutputStream = new ByteArrayOutputStream();
            pdfReader = new PdfReader(bytes);
            Rectangle rectangle = pdfReader.getPageSize(1);
            stamper = new PdfStamper(pdfReader, byteArrayOutputStream);
            PdfContentByte canvas = stamper.getUnderContent(1);
            //替换关键字
            canvas.beginText();
            BaseFont bf = BaseFont.createFont("STSong-Light", "UniGB-UCS2-H", BaseFont.EMBEDDED);
            canvas.setFontAndSize(bf, 13);
            canvas.showTextAligned(Element.ALIGN_CENTER, contentText, rectangle.getWidth() - 50, rectangle.getHeight() - 20, 0);/*修正背景与文本的相对位置*/
            canvas.endText();
        } catch (IOException e) {
            e.printStackTrace();
        } catch (DocumentException e) {
            e.printStackTrace();
        } finally {
            if (byteArrayOutputStream != null) {
                try {
                    byteArrayOutputStream.close();
                } catch (IOException e) {
                }
            }
            if (stamper != null)
                try {
                    stamper.close();
                } catch (DocumentException e) {
                    e.printStackTrace();
                } catch (IOException e) {
                    e.printStackTrace();
                }
            if (pdfReader != null) {
                pdfReader.close();
            }
        }
        return new ByteArrayInputStream(byteArrayOutputStream.toByteArray());
    }

    public static void main(String[] args) throws Exception {


        File pdfFile = new File("D:\\pdf\\test1664334027252.pdf");
        //2.定义一个byte数组，长度为文件的长度
        byte[] pdfData = new byte[(int) pdfFile.length()];
        //3.IO流读取文件内容到byte数组
        FileInputStream inputStream = null;
        try {
            inputStream = new FileInputStream(pdfFile);
            inputStream.read(pdfData);
            addText(pdfData, "dasfad");
        } catch (IOException e) {
            e.printStackTrace();
        } finally {
            if (inputStream != null) {
                try {
                    inputStream.close();
                } catch (IOException e) {
                }
            }
        }


    }
}
