package pps.core.common.utils;

import com.google.common.base.Strings;

import java.util.ArrayList;
import java.util.Set;

public class ThreadHelper {

    public static final String LINE_SEPERATOR = System.getProperty("line.separator");

    public static String buildThreadsSimpleInfos(StringBuilder sb) {

        if (sb == null) {
            sb = new StringBuilder();
        }
        try {
            Set<Thread> threadSet = Thread.getAllStackTraces().keySet();
            ArrayList<Thread> threads = new ArrayList<>(threadSet.size());
            threads.addAll(threadSet);
            threads.sort((x, y) -> x.getName().compareTo(y.getName()));

            //int i = 0;
            for (Thread t : threads) {
                //i++;
                sb.append(t.getName());
                sb.append("(");
                sb.append(t.getId());
                sb.append("),");
            }

            sb.append("TOTAL : ").append(threadSet.size());
        } catch (Exception ex) {

        }
        return sb.toString();
    }

    public static void buildThreadsInfos(StringBuilder sb) {
        if (sb == null) {
            sb = new StringBuilder();
        }
        Set<Thread> threadSet = Thread.getAllStackTraces().keySet();
        ArrayList<Thread> threads = new ArrayList<>(threadSet.size());
        threads.addAll(threadSet);
        threads.sort((x, y) -> x.getName().compareTo(y.getName()));

        //int i = 0;
        for (Thread t : threads) {
            //i++;
            sb.append("[");
            sb.append(t.getName());
            sb.append("] ID:");
            sb.append(t.getId());
            sb.append(LINE_SEPERATOR);
            sb.append(arrayToString(t.getStackTrace(), LINE_SEPERATOR));
            sb.append(LINE_SEPERATOR);
            sb.append(LINE_SEPERATOR);
        }
        sb.append("TOTAL : ").append(threadSet.size()).append(LINE_SEPERATOR);

        for (Thread item : threads) {
            sb.append(item.getName()).append(LINE_SEPERATOR);
        }

    }

    public static String arrayToString(Object[] a, String seperator) {
        if (a == null)
            return "null";

        int iMax = a.length - 1;
        if (iMax == -1)
            return "[]";

        if (Strings.isNullOrEmpty(seperator))
            seperator = ", ";

        StringBuilder b = new StringBuilder();
        b.append('[');
        for (int i = 0; ; i++) {
            b.append(String.valueOf(a[i]));
            if (i == iMax) {
                return b.append(']').toString();
            }
            b.append(seperator);
        }
    }
}
