package pps.core.system.constant;

/**
 * pps运维管理常量及工具
 */
public class OperationMaintenanceManagementConstants {
    /*
    0 未提交
    1 已提交
    2 审核中
    3 审批通过
    4 已驳回*/
    //未提交
    public static final int SAVED = 0;
    //搁置(空闲)2已经包括了提交
    public static final int SUBMITTED = 1;
    //已提交，审核中
    public static final int UNDER_REVIEW = 2;
    //审核通过
    public static final int PASSED = 3;
    //已驳回
    public static final int REJECT = 4;
    //终止流程
    public static final int TERMINATION = 5;

    //接受需求
    public static final int ACCEPTDEMAND = 6;


    /*
    4 不操作
    5 有中止
    6 有接受需求和终止
    7 有接受需求和终止但没有提交通过
   */
    //4 不操作
    public static final int NOOPERATION = 4;
    //5 有中止
    public static final int DISCONTINUE = 5;
    // 6 有接受需求和终止
    public static final int SUSPENSIONACCEPTANCE = 6;

    //7 有接受需求和终止但没有提交通过
    public static final int SUSPENDACCEPTSUBMISSIONS = 7;
}
