package pps.core.system.constant;

/**
 * @Description: 接收方式
 */
public enum SysInformReceiveTypeConstant {
    USER(1, "人员"),
    GROUP(2, "收件组"),
    ROLE(3, "角色"),
    ORG(4, "机构"),
    ROLE_BJDW(5, "角色-提交人本级单位"),
    ROLE_EJDW(6, "角色-提交人二级单位"),
    ROLE_SSQY(7, "角色-提交人所属企业"),
    ROLE_CCGC(8, "存储过程"),
    ROLE_QB(9, "全部"),
    ORG_CHILD(10, "机构（含子级）");


    private Integer value;
    private String desc;

    SysInformReceiveTypeConstant(Integer value, String desc) {
        this.value = value;
        this.desc = desc;
    }

    public static SysInformReceiveTypeConstant findByValue(Integer v) {
        for (SysInformReceiveTypeConstant e : values()) {
            if (e.getValue().equals(v)) {
                return e;
            }
        }
        return null;
    }

    public static SysInformReceiveTypeConstant findByDesc(String desc) {
        for (SysInformReceiveTypeConstant e : values()) {
            if (e.getDesc().equals(desc)) {
                return e;
            }
        }
        return null;
    }

    public Integer getValue() {
        return value;
    }

    public void setValue(Integer value) {
        this.value = value;
    }

    public String getDesc() {
        return desc;
    }

    public void setDesc(String desc) {
        this.desc = desc;
    }
}
