package pps.core.system.service;

import pps.core.system.entity.SysSmsGroupHideEnt;
import pps.core.system.mapper.SysSmsGroupHideMapper;
import pps.core.system.service.data.sys_sms_group_hide.CreateSysSmsGroupHideInput;
import pps.core.system.service.data.sys_sms_group_hide.DeleteSysSmsGroupHideInput;
import xstartup.annotation.XService;
import xstartup.base.XContext;
import xstartup.base.util.XCopyUtils;
import xstartup.data.XServiceResult;
import xstartup.feature.api.annotation.XApiAnonymous;
import xstartup.feature.api.annotation.XApiPost;

import java.util.HashMap;
import java.util.Map;

@XService
public class SysSmsGroupHideService {
    @XApiAnonymous
    @XApiPost
    public XServiceResult createSysSmsGroupHide(XContext context, CreateSysSmsGroupHideInput input) {
        SysSmsGroupHideMapper mapper = context.getBean(SysSmsGroupHideMapper.class);
        SysSmsGroupHideEnt entity = new SysSmsGroupHideEnt();
        XCopyUtils.copyObject(input, entity);
        mapper.insert(entity);
        return XServiceResult.OK;
    }

    @XApiAnonymous
    @XApiPost
    public XServiceResult deleteSysSmsGroupHide(XContext context, DeleteSysSmsGroupHideInput input) {
        SysSmsGroupHideMapper mapper = context.getBean(SysSmsGroupHideMapper.class);
        Map<String, Object> map = new HashMap<>();
        map.put("sms_group_id", input.getSmsGroupId());
        map.put("hide_create_by", input.getHideCreateBy());
        mapper.deleteByMap(map);
        return XServiceResult.OK;
    }
}