package pps.cloud.base.enums;

import com.baomidou.mybatisplus.annotation.EnumValue;

public enum PipelineLevelEnum {
    LEVEL_ONE(43, "1级", 1),
    LEVEL_TWO(44, "2级", 2),
    LEVEL_THREE(45, "3级", 3),
    LEVEL_FOUR(46, "4级", 4),
    LEVEL_FIVE(9918, "5级", 5),
    ;

    @EnumValue
    private Integer value;
    private String desc = "";
    private Integer oldValue;

    PipelineLevelEnum(Integer value, String desc, Integer oldValue) {
        this.value = value;
        this.desc = desc;
        this.oldValue = oldValue;
    }

    public static PipelineLevelEnum findByValue(Integer v) {
        for (PipelineLevelEnum e : values()) {
            if (e.getValue().equals(v)) {
                return e;
            }
        }
        return LEVEL_ONE;
    }

    public static PipelineLevelEnum findByOldValue(Integer v) {
        for (PipelineLevelEnum e : values()) {
            if (e.getOldValue().equals(v)) {
                return e;
            }
        }
        return LEVEL_ONE;
    }

    public Integer getValue() {
        return value;
    }

    public String getDesc() {
        return desc;
    }

    public Integer getOldValue() {
        return oldValue;
    }
}
