package pps.cloud.base.service;

import pps.cloud.base.service.data.BaseNameInput;
import pps.cloud.base.service.data.CommonIDInput;
import pps.cloud.base.service.data.base_pipeline.*;
import xstartup.annotation.XService;
import xstartup.annotation.XText;
import xstartup.base.XContext;
import xstartup.data.XListResult;
import xstartup.data.XSingleResult;

@XService
public interface BaseBasePipelineService {

    @XText("根据管线id获取管线信息")
    XSingleResult<QueryPipelineByIdOutput> getPipelineById(XContext context, CommonIDInput input);

    @XText("获取场站当前所属的管线信息")
    XListResult<SelectPipelineListByStationIdOutput> selectPipelineListByStationId(XContext context, CommonIDInput input);

    @XText("根据管线id获取管线信息")
    XListResult<QueryPipelineByIdsOutput> queryPipelineByPipelineIds(XContext context, QueryPipelineByIdsInput input);

    @XText("根据管线id获取1级管线信息")
    XListResult<QueryPipelineByIdsOutput> queryPipelineByPipelineIdsOne(XContext context, QueryPipelineByIdsInput input);

    @XText("根据管线名称获取管线信息")
    XListResult<QueryPipelineByIdsOutput> queryPipelineByPipelineNames(XContext context, QueryPipelineByIdsInput input);

    @XText("根据管线名称获取管线信息")
    XSingleResult<PipelineListOutput> selectPipelineByPipelineName(XContext context, BaseNameInput input);

    @XText("根据管线id获取下级管线信息")
    XListResult<PipelineListOutput> selectDownPipelineByPipelineId(XContext context, PipelineIdInput input);

    @XText("根据管线id获取对应调度台下级管线信息")
    XListResult<PipelineListOutput> selectDispatchingDownPipelineByPipelineId(XContext context, PipelineIdInput input);

    @XText("根据调度台获取管线信息")
    XListResult<PipelineListOutput> selectPipelineByDispatchDesk(XContext context, GetPipelineByDispatchInput input);

    @XText("根据管线获取管线信息")
    XSingleResult<QueryPipelineByIdsOutput> selectPipelinebyId(XContext context, CommonIDInput input);

    @XText("根据管线id获取管线信息（地区公司）")
    XListResult<QueryPipelineByIdOutput> selectPipelineIdByenterprise(XContext context, QueryPipelineByIdInput input);

    @XText("根据地区公司id获取管线信息")
    XListResult<PipelineListOutput> selectPipelineByEnterpriseId(XContext context, GetPipelineByEnterpriseIdInput input);

    @XText("获取操作员管理的管线信息")
    XListResult<SelectPipelineByOperatorOutput> selectPipelineByOperator(XContext context);
}
