package pps.cloud.base.service;

import pps.cloud.base.service.data.*;
import pps.cloud.base.service.data.base_pipeline.QueryPipelineByIdInput;
import xstartup.annotation.XService;
import xstartup.annotation.XText;
import xstartup.base.XContext;
import xstartup.data.XListResult;
import xstartup.data.XServiceResult;
import xstartup.data.XSingleResult;


@XService
public interface BaseBaseStationService {

    @XText("根据id获取场站")
    XSingleResult<QueryBaseStationOutput> selectStationById(XContext context, BaseStationIdInput input);

    @XText("根据场站id获取组织机构信息")
    XSingleResult<GetOuByStationIdOutput> getOuByStationId(XContext context, GetOuByStationIdInput input);

    @XText("根据id获取场站")
    XListResult<QueryBaseStationOutput> selectStationListByStationIds(XContext context, QueryBaseStationInput input);

    @XText("根据名称获取场站")
    XListResult<QueryBaseStationOutput> selectStationListByStationNames(XContext context, QueryBaseStationInput input);

    @XText("根据场站名称获取场站")
    XSingleResult<QueryBaseStationOutput> selectStationListByStationName(XContext context, GetBaseStationByNameInput input);

    @XText("获取用户范围授权的场站id")
    XListResult<QueryBaseStationOutput> getStationIdsWithUser(XContext context, GetStationIdsWithUserInput input);

    @XText("根据组织机构id获取场站信息")
    XListResult<QueryBaseStationOutput> selectStationListByOuId(XContext context, BaseOuIdInput input);

    @XText("根据组织机构id获取场站信息")
    XListResult<GetBaseStationForFlowMeterOutput> selectStationListByOuIdForFlowMeter(XContext context, GetBaseStationForFlowMeterInput input);

    @XText("根据场站id获取场站的组织机构信息")
    XListResult<QueryBaseStationOutput> selectStationOuByStationId(XContext context, BaseStationIdInput input);

    @XText("根据组织机构id获取所有下级信息")
    XListResult<QueryBaseStationOutput> selectAllChildByOuId(XContext context, BaseOuIdInput input);

    @XText("根据管线id获取所有场站")
    XListResult<QueryBaseStationOutput> selectStationByPipelineId(XContext context, QueryBaseStationInput input);

    @XText("根据管线id获取所有场站-模板下载")
    XListResult<QueryBaseStationExcelOutput> selectStationByPipelineIdExcel(XContext context, QueryPipelineByIdInput input);

    XListResult<QueryBaseStationOutput> selectStationAllByStationName(XContext context, QueryBaseStationInput input);

    @XText("根据管线id获取所有场站-模板下载")
    XServiceResult createBaseStation(XContext context, CreateBaseStationInput input);
}
