package pps.core.base.service;

import pps.cloud.base.service.FBaseDownloadFlowmeterService;
import pps.cloud.base.service.data.base_download_flowmeter.GetFBaseDownloadFlowmeterViewInput;
import pps.cloud.base.service.data.base_download_flowmeter.GetFBaseDownloadFlowmeterViewOutput;
import pps.core.base.entity.FBaseDownloadFlowmeterView;
import pps.core.base.mapper.FBaseDownloadFlowmeterViewMapper;
import xstartup.annotation.XService;
import xstartup.annotation.XText;
import xstartup.base.XContext;
import xstartup.base.util.XCopyUtils;
import xstartup.data.XListResult;

import java.util.List;

@XService
@XText("天然气计量交接凭证-流量计-批量")
public class FBaseDownloadFlowmeterServiceImpl implements FBaseDownloadFlowmeterService {
    @Override
    @XText("根据场站id获取需要填报的数据")
    public XListResult<GetFBaseDownloadFlowmeterViewOutput> selectListByStationId(XContext context, GetFBaseDownloadFlowmeterViewInput input) {
        FBaseDownloadFlowmeterViewMapper mapper = context.getBean(FBaseDownloadFlowmeterViewMapper.class);
        FBaseDownloadFlowmeterView view = XCopyUtils.copyNewObject(input, FBaseDownloadFlowmeterView.class);
        List<GetFBaseDownloadFlowmeterViewOutput> outputs = mapper.selectList(view);
        return XListResult.success(outputs);
    }
}
