package pps.core.base.service;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import pps.cloud.base.service.GasDayPlanConfigService;
import pps.cloud.base.service.data.GetGasDayPlanConfigInput;
import pps.cloud.base.service.data.GetGasDayPlanConfigOutput;
import pps.core.base.entity.GasDayPlanConfigEnt;
import pps.core.base.entity.GasUploadDayPlanConfigEnt;
import pps.core.base.mapper.GasDayPlanConfigMapper;
import pps.core.base.mapper.GasUploadDayPlanConfigMapper;
import xstartup.annotation.XService;
import xstartup.base.XContext;
import xstartup.base.util.XCopyUtils;
import xstartup.data.XSingleResult;
import xstartup.error.XError;

@XService
public class GasDayPlanConfigServiceImpl implements GasDayPlanConfigService {

    @Override
    public XSingleResult<GetGasDayPlanConfigOutput> getDayPlanConfig(XContext context, GetGasDayPlanConfigInput input) {
        GetGasDayPlanConfigOutput output = new GetGasDayPlanConfigOutput();
        GasDayPlanConfigMapper mapper = context.getBean(GasDayPlanConfigMapper.class);
        QueryWrapper<GasDayPlanConfigEnt> queryWrapper = new QueryWrapper<>();
        if (input.getDayPlanDid() != null) {
            queryWrapper.lambda().eq(GasDayPlanConfigEnt::getDayPlanDid, input.getDayPlanDid());
        }
        if (input.getRemarkDid() != null) {
            queryWrapper.lambda().eq(GasDayPlanConfigEnt::getRemarkDid, input.getRemarkDid());
        }
        queryWrapper.lambda().last("limit 1");
        GasDayPlanConfigEnt entity = mapper.selectOne(queryWrapper);
        if (entity == null) {
            GasUploadDayPlanConfigMapper upMapper = context.getBean(GasUploadDayPlanConfigMapper.class);
            QueryWrapper<GasUploadDayPlanConfigEnt> upQueryWrapper = new QueryWrapper<>();
            if (input.getDayPlanDid() != null) {
                upQueryWrapper.lambda().eq(GasUploadDayPlanConfigEnt::getDayPlanDid, input.getDayPlanDid());
            }
            if (input.getRemarkDid() != null) {
                upQueryWrapper.lambda().eq(GasUploadDayPlanConfigEnt::getRemarkDid, input.getRemarkDid());
            }
            upQueryWrapper.lambda().last("limit 1");
            GasUploadDayPlanConfigEnt upEntity = upMapper.selectOne(upQueryWrapper);
            if (upEntity == null) {
                context.getLogger().warn("dataDefineId-not-exists：" + input.getDayPlanDid());
                return XSingleResult.error(context, XError.NotFound);
            }
            XCopyUtils.copyObject(upEntity, output);
            output.setCustomerId(upEntity.getSourceId());
            output.setCustomerName(upEntity.getSourceName());
            output.setUpDown(1);
        } else {
            XCopyUtils.copyObject(entity, output);
            output.setUpDown(2);
        }
        return XSingleResult.success(output);
    }
}
