package pps.core.base.service;

import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.text.CharSequenceUtil;
import pps.cloud.system.service.SysOrganizationCloudService;
import pps.cloud.system.service.data.GetSysOrganizationViewOutput;
import pps.core.base.config.excel.ExcelDynamicSelect;
import xstartup.base.XSelfServiceContext;
import xstartup.data.XListResult;

import java.util.List;
import java.util.stream.Collectors;

/**
 * 采油厂下拉选
 *
 * @author ZWT
 * @date 2024/05/07 10:28
 */
public class OilExtractionPlantImpl implements ExcelDynamicSelect {

    @Override
    public String[] getSource() {
        XSelfServiceContext build = XSelfServiceContext.build(SysOrganizationCloudService.class);
        SysOrganizationCloudService bean = build.getBean(SysOrganizationCloudService.class);
        XListResult<GetSysOrganizationViewOutput> result = bean.getPlantList(build);
        result.throwIfFail();
        List<GetSysOrganizationViewOutput> list = result.getResult();
        if (CollUtil.isNotEmpty(list)) {
            return CharSequenceUtil.splitToArray(list.stream()
                    .map(GetSysOrganizationViewOutput::getOuName)
                    .collect(Collectors.joining(",")), ",");
        }
        return new String[0];
    }
}