package pps.core.space.mapper;

import org.apache.ibatis.annotations.Param;
import org.springframework.stereotype.Repository;
import pps.core.space.entity.SpaceInstitutionWellheadView;

import java.util.Collection;
import java.util.List;

/**
 * 间开制度井口配置
 *
 * @author ZWT
 * @date 2023/09/05
 */
@Repository(value = "pps.core.space.mapper.SpaceInstitutionWellheadViewMapper")
public interface SpaceInstitutionWellheadViewMapper {
    SpaceInstitutionWellheadView selectOne(SpaceInstitutionWellheadView record);

    List<SpaceInstitutionWellheadView> selectList(SpaceInstitutionWellheadView record);

    /**
     * 批量新增
     *
     * @param list 列表
     * @return int
     */
    int batchInsertList(@Param(value = "list") List<SpaceInstitutionWellheadView> list);

    /**
     * 通过制度ID集合获取所有间开井口
     *
     * @param institutionIds 机构ID
     * @return {@link List}<{@link SpaceInstitutionWellheadView}>
     */
    List<SpaceInstitutionWellheadView> selectListByInstitutionIds(@Param(value = "list") Collection institutionIds);

    /**
     * 通过制度ID集合获取所有间开井口
     *
     * @param institutionIds 机构ID
     * @return {@link List}<{@link SpaceInstitutionWellheadView}>
     */
    List<SpaceInstitutionWellheadView> selectWellheadsByInstitutionIds(@Param(value = "list") Collection institutionIds);
}
