package pps.core.space.service.data;

import cn.hutool.core.date.DateTime;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;
import xstartup.annotation.XText;

/**
 * 权重间开
 *
 * @author ZWT
 * @date 2024/04/12 14:26
 */
@Data
@NoArgsConstructor
@AllArgsConstructor
@Builder
public class SpaceOptimizeWeightDuration {

    @XText("开井时间")
    private DateTime openTime;

    @XText("关井时间")
    private DateTime closeTime;

    @XText("开井索引")
    private int openIndex;

    @XText("关井索引")
    private int closeIndex;

    @XText("开井时长(分钟)")
    private long duration;

    @XText("权重")
    private int weight;

    @XText("需要优化的索引")
    private int optimizeIndex;
}
