package pps.core.prediction.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import lombok.Data;
import xstartup.annotation.XText;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;

/**
 * 第三方井场日累计数据(每日最新数据)
 *
 * @author ZWT
 * @date 2024/04/02
 */
@Data
@TableName("third_daily_accumulation_update")
public class ThirdDailyAccumulationUpdateEnt implements Serializable {
    @XText("ID")
    @TableId(type = IdType.AUTO)
    private Long id;

    @XText("井组名称(线路/光伏电站)")
    @TableField
    private String stationName;

    @XText("井组ID(光伏电站)")
    @TableField
    private String stationId;

    @XText("创建时间")
    @TableField
    private Date createDate;

    @XText("光伏日累计发电(KWh)")
    @TableField
    private BigDecimal photovoltaicPower;

    @XText("日累计用电量(KW·h)")
    @TableField
    private BigDecimal dailyElectricityConsumption;

    @XText("日累计产液量(m³)")
    @TableField
    private BigDecimal dailyLiquidProduction;

    @XText("就地消纳电量(KWh)")
    @TableField
    private BigDecimal inPlaceConsumption;

    @XText("入库日期")
    @TableField
    private Date saveDate;

    @XText("来源系统")
    @TableField
    private String systemSource;

    @XText("保存时间")
    @TableField
    private Date saveHour;
}
