package pps.core.prediction.service;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import pps.core.prediction.entity.PlantPredictedPowerUltraTermEnt;
import pps.core.prediction.mapper.PlantPredictedPowerUltraTermMapper;
import pps.core.prediction.service.data.plant_predicted_power_mid_term.GetPlantPredictedPowerMidTermOutput;
import pps.core.prediction.service.data.plant_predicted_power_ultra_term.GetPlantPredictedPowerUltraTermInput;
import xstartup.annotation.XService;
import xstartup.annotation.XText;
import xstartup.base.XContext;
import xstartup.base.util.XCopyUtils;
import xstartup.base.util.XDateUtils;
import xstartup.base.util.XStringUtils;
import xstartup.data.XListResult;
import xstartup.feature.api.annotation.XApiGet;

import java.util.Date;
import java.util.List;


@XService
@XText("电站预测功率4小时数据")
public class PlantPredictedPowerUltraTermService {

    @XApiGet
    @XText("根据电站预测功率4小时数据")
    public XListResult<GetPlantPredictedPowerMidTermOutput> getPlantPredictedPowerUltraTermList(XContext context, GetPlantPredictedPowerUltraTermInput input) {
        //4小时数据，往前推1天，往后推4小时
        PlantPredictedPowerUltraTermMapper mapper = context.getBean(PlantPredictedPowerUltraTermMapper.class);
        String startTime;
        String endTime;
        if (XStringUtils.isEmpty(input.getStartTime())) {
            startTime = XDateUtils.getString(XDateUtils.addDays(new Date(), -1));
            endTime = XDateUtils.getString(XDateUtils.addHours(new Date(), 4));
        } else {
            Date dateString = XDateUtils.parse(XDateUtils.getDateString(new Date()) + " " + input.getStartTime() + ":00");
            startTime = XDateUtils.getString(XDateUtils.addDays(dateString, -1));
            endTime = XDateUtils.getString(XDateUtils.addHours(dateString, 4));
        }
        QueryWrapper<PlantPredictedPowerUltraTermEnt> queryWrapper = setQueryWrapper(input.getPlantId(), startTime, endTime);
        List<PlantPredictedPowerUltraTermEnt> list = mapper.selectList(queryWrapper);
        List<GetPlantPredictedPowerMidTermOutput> outputs = XCopyUtils.copyNewList(list, GetPlantPredictedPowerMidTermOutput.class);
        ThirdActivePowerServiceHelper.getActivePower(context, outputs, input.getPlantId());
        return XListResult.success(outputs);
    }

    private QueryWrapper<PlantPredictedPowerUltraTermEnt> setQueryWrapper(String plantId, String startTime, String endTime) {
        QueryWrapper<PlantPredictedPowerUltraTermEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(PlantPredictedPowerUltraTermEnt::getPlantId, plantId);
        queryWrapper.lambda().ge(PlantPredictedPowerUltraTermEnt::getDataDate, startTime);
        queryWrapper.lambda().le(PlantPredictedPowerUltraTermEnt::getDataDate, endTime);
        queryWrapper.lambda().orderByAsc(PlantPredictedPowerUltraTermEnt::getDataDate);
        return queryWrapper;
    }
}